<template>
    <Tile :addClass="addClass" :widthClass="widthClass">
        <p class="text-center font-bold text-lg mb-3">{{ titleChart }}</p>
        <canvas ref="canvasEl"></canvas>
    </Tile>
</template>

<script>
import Chart from "chart.js/auto";
import Tile from "../Tile.vue";
import { ref } from '@vue/reactivity';
import { onMounted, onUpdated } from '@vue/runtime-core';

export default {
    name: "Line",
    components: {
        Tile
    },
    props: {
        addClass: String,
        widthClass: String,
        titleChart: String,
        labels: Array,
        datasets: Array,
        options: Object,
        type: String
    },
    setup(props) {
        const canvasEl = ref(null);
        let chart = null;

        const showChart = (canvas) => {
            chart = new Chart(canvas, {
                type: props.type,
                data: {
                    labels: props.labels,
                    datasets: props.datasets
                },
                options: props.options
            })
        }

        onUpdated(() => {
            chart.destroy();
            showChart(canvasEl.value)
        })
        
        onMounted(() => {
            showChart(canvasEl.value)
        })

        return {
            canvasEl
        }
    }
}
</script>

<style>

</style>